--[[ borlox 2009-05-02T11:51:51Z 30adc16 ]]--
local CCopy = LibStub("AceAddon-3.0"):NewAddon("CCopy", "AceHook-3.0")

---------------------------------------------------------------------
---- Configuration

-- This string is displayed before saved chat lines
local MARKER = '*'

-- Show the time instead of the marker above
local SHOW_TIME = false

-- Format string for the time (see http://www.opengroup.org/onlinepubs/007908799/xsh/strftime.html)
local TIME_FMT = "[%H:%M:%S]"

---- You should not touch anything beyond this line...
---------------------------------------------------------------------

local link_msg = "|HCCopy|h%s|h %s"
local link_regex = "|HCCopy|h(.-)|h "

local ChatFrameEditBox = ChatFrameEditBox

function CCopy:OnEnable()
	self:RawHook("ChatFrame_OnHyperlinkShow", true)
	local _G = _G
	for i=1, NUM_CHAT_WINDOWS do
		self:RawHook(_G["ChatFrame"..i], "AddMessage", true)
	end
end

function CCopy:ClearMessage(msg)
	msg = msg:gsub(link_regex, "") -- clear CCopy marker
	msg = msg:gsub("|H.-|h(.-)|h", "%1")	-- clear links
	msg = msg:gsub("|c%x%x%x%x%x%x%x%x(.-)|r", "%1") -- clear colors
	return msg
end

function CCopy:ShowMessage(msg)
	msg = self:ClearMessage(msg)
	
	ChatFrameEditBox:SetText(ChatFrameEditBox:GetText() .. msg)
	if not ChatFrameEditBox:IsShown() then
		ChatFrameEditBox:Show()
		ChatFrameEditBox:HighlightText()
	end
end

function CCopy:AddMessage(chatFrame, msg, ...)
	msg = link_msg:format(SHOW_TIME and date(TIME_FMT) or MARKER, msg)
	self.hooks[chatFrame].AddMessage(chatFrame, msg, ...)
end

function CCopy:ChatFrame_OnHyperlinkShow(chatframe, link, text, button)
	if link:sub(1, 5) == "CCopy" then
		local frame = GetMouseFocus()
		
		if not frame:IsObjectType("Button") then
			return
		end
		
		local fontString = select(2, frame:GetPoint(1))
		
		if not fontString:IsObjectType("FontString") then
			return
		end

		self:ShowMessage(fontString:GetText())
	else
		return self.hooks.ChatFrame_OnHyperlinkShow(chatframe, link, text, button)
	end
end
